// file: $DT/class/decision_tree/v1.0/decision_tree_constants.h
//
 
// make sure the definitions are made only once
//
#ifndef __ISIP_DECISION_TREE_CONSTANTS
#define __ISIP_DECISION_TREE_CONSTANTS

// isip include files
//
#ifndef __ISIP_INTEGRAL
#include <integral.h>
#endif

// define the class name
//
#define DECISION_TREE_CLASS_NAME (char_1*)"Decision_tree"

// define limitations
//
#define DT_MAX_ATTR_FILE_SIZE (int_4)65536
#define DT_MAX_NUM_OF_ATTR_VALUES (int_4)64
#define DT_MAX_BUFFER_SIZE (int_4)8192
#define DT_MINIMUM_FLOAT_4 (float_4)-1.17549435e+38
#define DT_MAXIMUM_FLOAT_4 (float_4)1.17549435e+38

// define the confidence limit for use in C4 pruning
//
#define DT_CONFIDENCE_LIMIT (char_1*)"confidence_limit"
#define DT_CONFIDENCE_LIMIT_VALUE (float_4)0.25

// define the prior model and its available values
//
#define DT_PRIOR_MODEL (char_1*)"prior_model"
#define DT_PRIOR_MODEL_UNIFORM_NAME (char_1*)"uniform"
#define DT_PRIOR_MODEL_UNIFORM (int_4)0

// define the dirichlet prior and its default value
//
#define DT_DIRICHLET_PRIOR (char_1*)"dirichlet_prior"
#define DT_DIRICHLET_PRIOR_DEFAULT_VALUE (float_4)1.0

// define threshold constants
//
#define DT_EPSILON (float_4)1e-6

// define debugging levels
//
#define DT_DEBUG_LEVEL (char_1*)"debug_level"

// define available modes
//
#define DT_MODE (char_1*)"mode"
#define DT_MODE_NONE (int_4)-1
 
#define DT_MODE_TEST (int_4)0
#define DT_MODE_TEST_NAME (char_1*)"test"
 
#define DT_MODE_TRAIN (int_4)1
#define DT_MODE_TRAIN_NAME (char_1*)"train"

#define DT_MODE_PRUNE (int_4)2
#define DT_MODE_PRUNE_NAME (char_1*)"prune"

// define available splitting algorithms
//
#define DT_SPLIT (char_1*)"splitting_algorithm"
#define DT_SPLIT_NONE (int_4)-1

#define DT_SPLIT_ENT (int_4)0
#define DT_SPLIT_ENT_NAME (char_1*)"entropy"

#define DT_SPLIT_BAYES (int_4)1
#define DT_SPLIT_BAYES_NAME (char_1*)"bayes"

#define DT_SPLIT_GAINRATIO (int_4)2
#define DT_SPLIT_GAINRATIO_NAME (char_1*)"gain_ratio"

#define DT_SPLIT_IND_GAINRATIO (int_4)3
#define DT_SPLIT_IND_GAINRATIO_NAME (char_1*)"ind_gain_ratio"

// define available splitting search methods, complete is to search
// through all combinations of attribute splitting possible, fast is
// to isolate single attribute
//
#define DT_SEARCH (char_1*)"attribute_searching"

#define DT_SEARCH_COMPLETE (int_4)0
#define DT_SEARCH_COMPLETE_NAME (char_1*)"complete"

#define DT_SEARCH_FAST (int_4)1
#define DT_SEARCH_FAST_NAME (char_1*)"fast"

// define available pruning algorithms
//
#define DT_PRUNE (char_1*)"pruning_algorithm"
#define DT_PRUNE_NONE (int_4)-1

#define DT_PRUNE_PESSIMISTIC (int_4)0
#define DT_PRUNE_PESSIMISTIC_NAME (char_1*)"pessimistic"

#define DT_PRUNE_COSTCOMPLEXITY (int_4)1
#define DT_PRUNE_COSTCOMPLEXITY_NAME (char_1*)"cost_complexity"

// define available smoothing algorithms
//
#define DT_SMOOTH (char_1*)"smoothing_algorithm"
#define DT_SMOOTH_NONE (int_4)-1
#define DT_SMOOTH_BAYES (int_4)0
#define DT_SMOOTH_BAYES_NAME (char_1*)"bayes"

// define display level
//
#define DT_DISPLAY (char_1*)"display"
#define DT_DISPLAY_NONE (int_4)-1

#define DT_DISPLAY_BASIC (int_4)0
#define DT_DISPLAY_BASIC_NAME (char_1*)"basic"

#define DT_DISPLAY_COUNT (int_4)1
#define DT_DISPLAY_COUNT_NAME (char_1*)"count"

#define DT_DISPLAY_PROB (int_4)2
#define DT_DISPLAY_PROB_NAME (char_1*)"prob"

// define name for the tree file
//
#define DT_TREE_FILENAME (char_1*)"tree_file"

// define comment tag for tree
//
#define DT_COMMENT (char_1)#

// define return value for finding max index
#define DT_MAX_ATTR_NOT_FOUND (int_4)-1

// define if data goes to left or right node
//
#define DT_SPLIT_LEFT (int_4)0
#define DT_SPLIT_RIGHT (int_4)1

// end of file
//
#endif



