// file: $DT/class/tree/v1.0/dt_cal_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: discrete_bayes_split_cc
//
// arguments: 
//
// return: logical_1 indicating success
//
// this method calculates initial value and the iteration value for
// the attribute splitting loop
//
logical_1 Decision_tree::calculate_loop_values_cc(int_4& init_a, int_4& iter_a,
						  int_4 num_categories_a) {

  if (mode_search_d == DT_SEARCH_COMPLETE) {
    init_a = 1;
    iter_a = (int_4) pow(2,(num_categories_a - 1));
  }

  // calculate for fast algorithm
  //
  else if (mode_search_d == DT_SEARCH_FAST) {
    init_a = 0;
    iter_a = num_categories_a;
  }

  else {
    error_handler_cc((char_1*)"calculate_loop_values_cc",
		     (char_1*)"unrecognized attribute split search method");
  }
  
  return ISIP_TRUE;
}


















