// file: $DT/class/decision_tree/v1.0/dt_check_0.cc
//

// isip include files
//
#include <decision_tree.h>
#include <decision_tree_constants.h>
#include <integral_constants.h>
#include <string.h>

// method: check_data_cc
//
// arguments:
//  int_4    num_item (input) the number of items passed in
//  char_1** data (input) the list of parsed items
//
// return: a logical_1 indicating status
//
logical_1 Decision_tree::check_data_cc(int_4 num_item_a,
				       char_1** data_a) {

  // check arguments
  //
  if ((num_item_a <= 0) || (num_item_a > DT_MAX_NUM_OF_ATTR_VALUES)) {
    error_handler_cc((char_1*)"check_data_cc",
		     (char_1*)"invalid number of data items");
  }

  if (data_a == (char_1**)NULL) {
    error_handler_cc((char_1*)"check_data_cc",
		     (char_1*)"no data items to check");
  }

  // loop through to check each item
  //
  for (int_4 i=0; i<num_item_a; i++) {
    if ((data_a[i] == (char_1*)NULL) ||
	(data_a[i][0] == ':') ||
	(data_a[i][strlen((char*)data_a[i])-1] == ':')) {
      return ISIP_FALSE;
    }
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}
