// file: $DT/class/decision_tree/v1.0/dt_comp_0.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"

#include <integral_constants.h>

// method: compute_cc
//
// arguments:
//  char_1* data_fname_a: (input) data filename
//  char_1* result_fname_a: (input) filename where results should go
//
// return: a logical_1 indicating status
//
// this method builds a decision tree from a set of examples or classifies
// the examples given a decision tree already built
//
logical_1 Decision_tree::compute_cc (char_1* data_fname_a,
				     char_1* result_fname_a ) {
  
  // load in the input data
  //
  if (load_data_cc(data_fname_a) != ISIP_TRUE) {
    error_handler_cc((char_1*)"compute_cc", (char_1*)"unable to load data");
  }

  if (debug_level_d > ISIP_DEBUG_NONE) {
    display_data_cc();
  }

  if (mode_d == DT_MODE_NONE) {
    
    // do nothing return
    //
    return ISIP_TRUE;
  }

  // train
  //
  else if (mode_d == DT_MODE_TRAIN) {

    if (train_cc(result_fname_a) != ISIP_TRUE) {

      // error
      //
      error_handler_cc((char_1*)"compute_cc",
		       (char_1*)"unable to train a decision tree");
    }
  }

  // prune
  //
  else if (mode_d == DT_MODE_PRUNE) {

    if (prune_cc(result_fname_a) != ISIP_TRUE) {

      // error
      //
      error_handler_cc((char_1*)"compute_cc",
		       (char_1*)"unable to prune a decision tree");
    }
  }

  // test
  //
  else if (mode_d == DT_MODE_TEST) {

    if (test_cc(result_fname_a) != ISIP_TRUE) {

      // error
      //
      error_handler_cc((char_1*)"compute_cc",
		       (char_1*)"unable to classify data using an existing tree");
    }
  }

  // invalid mode
  //
  else {

    // invalid mode
    //
    error_handler_cc((char_1*)"compute_cc", (char_1*)"invalid mode");
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
