// file: $DT/class/decision_tree/v1.0/dt_cstr_0.cc
//

// isip include files
//
#include <integral_constants.h>
#include "decision_tree.h"
#include <attribute_node.h>
#include <data_node.h>
#include <tree.h>

// method: default destructor
//
// arguments: none
//
// return: none
//
Decision_tree::~Decision_tree() {
  
  //  printf("DT destructor: %u\n", (uint_2)this);
 
  // general data needing cleanup
  //
  if (param_fname_d != (char_1*)NULL) {
    delete [] param_fname_d;
  }

  if (attr_fname_d != (char_1*)NULL) {
    delete [] attr_fname_d;
  }

  if (data_fname_d != (char_1*)NULL) {
    delete [] data_fname_d;
  }

  if (tree_fname_d != (char_1*)NULL) {
    delete [] tree_fname_d;
  }

  if (class_names_d != (char_1**)NULL) {
    for (int_4 i=0; i<num_classes_d; i++) {
      if (class_names_d[i] != (char_1*)NULL) {
	delete [] class_names_d[i];
      }
    }
    delete [] class_names_d;
  }

  if (class_node_d != (Attribute_node*)NULL) {
    delete class_node_d;
  }

  if (class_prior_probs_d != (float_4*)NULL) {
      delete [] class_prior_probs_d;
  }

  // delete the attribute list and the data list
  // make sure we delete the node because Linked_list destructor
  // only delete the link not the node
  //
  if (attribute_list_d != (Linked_list*)NULL) {
    Linked_list* attr_ll_temp = attribute_list_d;
    
    Attribute_node* attr_node_temp;

    // delete the nodes contained in the linked list
    //
    while (attr_ll_temp != (Linked_list*)NULL) {
      attr_node_temp = (Attribute_node*)attr_ll_temp->get_node_cc();
      if (attr_node_temp != (Attribute_node*)NULL) {
	delete attr_node_temp;
      }
      attr_ll_temp = attr_ll_temp->get_next_cc();
    }
    delete attribute_list_d;
  }

  if (data_list_d != (Linked_list*)NULL) {
    Linked_list* data_ll_temp = data_list_d;
    
    Data_node* data_node_temp;

    // delete the nodes contained in the linked list
    //
    while (data_ll_temp != (Linked_list*)NULL) {
      data_node_temp = (Data_node*)data_ll_temp->get_node_cc();
      if (data_node_temp != (Data_node*)NULL) {
	delete data_node_temp;
      }
      data_ll_temp = data_ll_temp->get_next_cc();
    }
    delete data_list_d;
  }

  if (tree_d != (Tree*)NULL) {
    delete tree_d;
  }
  
  // exit gracefully
  //
}


