// file: $DT/class/decision_tree/v1.0/dt_load_4.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include <data_node.h>
#include <linked_list.h>
#include "decision_tree.h"

#include <integral_constants.h>
#include "decision_tree_constants.h"

// method: load_data_cc
//
// arguments:
//  char_1* fname_a: (input) name of data file
//
// return: a logical_1 indicating status
//
// this method loads in the data to build the tree or data to be evaluated
//
//
logical_1 Decision_tree::load_data_cc (char_1* fname_a) {

  // argument validity check
  //
  if (fname_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"load_data_cc",
                     (char_1*)"data file is not valid");
  }

  // error already has a data file
  //
  if (data_fname_d != (char_1*)NULL) {
    error_handler_cc((char_1*)"load_data_cc",
                     (char_1*)"data_fname_d already has a value");
  }
  data_fname_d = new char_1[strlen((char*)fname_a)+1];
  strcpy((char*)data_fname_d, (char*)fname_a);

  // open the file
  //
  FILE* fp_a = (FILE*)NULL;
  fp_a = fopen ((char*)fname_a, "r");

  if (fp_a == (FILE*)NULL) {
    error_handler_cc((char_1*)"load_data_cc",
		     (char_1*)"unable to open data file");
  }
  
  // declare useful variables for the data node creation
  //
  char_1* buffer = new char_1[DT_MAX_BUFFER_SIZE];
  int_4 num_attr = 0;
  char_1** data_item = new char_1*[DT_MAX_NUM_OF_ATTR_VALUES+3];

  for (int_4 i=0; i<DT_MAX_NUM_OF_ATTR_VALUES+3; i++) {
    data_item[i] = new char_1[ISIP_MAX_STRING_LENGTH];
  }

  memset(buffer, 0, DT_MAX_BUFFER_SIZE);

  // read in the file
  //
  while (fgets((char*)buffer, DT_MAX_BUFFER_SIZE, fp_a) != (char*)NULL) {

    // skip the line if no ':' is found
    //
    if (strstr((char*)buffer, (char*)":") != NULL) {

      // parse the data into <label:value>
      //
      parse_data_cc(buffer, num_attr, data_item);
      if (check_data_cc(num_attr, data_item) == ISIP_FALSE) {
	error_handler_cc((char_1*)"load_data_cc",
			 (char_1*)"invalid item to set");
      }
      generate_data_node_cc(data_item, num_attr);
    }
  }

  // final clean up
  //
  if (data_item != (char_1**)NULL) {
    for (int_4 i=0; i<DT_MAX_NUM_OF_ATTR_VALUES+3; i++) {
      if (data_item[i] != (char_1*)NULL) {
	delete [] data_item[i];
      }
    }
    delete [] data_item;
    data_item = (char_1**)NULL;
  }
  if (buffer != (char_1*)NULL) {
    delete [] buffer;
  }
  buffer = (char_1*)NULL;

  fclose (fp_a);
  
  //  auto_range_cc();
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


