// file: $DT/class/decision_tree/v1.0/dt_prune_4.cc
//

// isip include files
//
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: prune_cc
//
// arguments:
//  char_1* output_fname_a (input): the output file name
//
// return: a logical_1 indicating status of success
//
logical_1 Decision_tree::prune_cc (char_1* output_fname_a) {

  // load in the tree
  //
  if (load_tree_cc() != ISIP_TRUE) {

    // error and exit
    //
    error_handler_cc((char_1*)"prune_cc", (char_1*)"unable to load in tree");
  }

  // call function to begin pruning
  //
  if (prune_cc(mode_prune_d) != ISIP_TRUE) {
    error_handler_cc((char_1*)"train_cc",
		     (char_1*)"error pruning tree");
  }

  // output final tree
  //
  write_cc(tree_fname_d);
  
  // save the built tree to a file
  //
  int_4 display_mode = get_display_mode_cc();

  if (output_fname_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"prune_cc",
		     (char_1*)"filename is NULL");
  }

  FILE* fp_out = fopen((char*)output_fname_a, "w");
  
  if (fp_out == (FILE*)NULL) {
    error_handler_cc((char_1*)"prune_cc",
		     (char_1*)"unable to create file for writing");
  }
  
  if (display_cc(fp_out, display_mode) != ISIP_TRUE) {
    error_handler_cc((char_1*)"prune_cc",
		     (char_1*)"unable to display tree");
  }
    
  // exit gracefully
  //
  return ISIP_TRUE;
}


