// file: $DT/class/decision_tree/v1.0/dt_set_1.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "tree.h"    
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: set_children_cc
//
// arguments:
//  char_1* param: (input) parameter string
//  char_1* value: (input) value string
//
// return: a logical_1 indicating status
//
// This function sets a given parameter (param) to a value (value)
//
logical_1 Decision_tree::set_children_cc(Tree_node* left_child_a,
					 Tree_node* right_child_a,
					 Tree_node* node_a,
					 float_4* left_prob_a,
					 float_4* right_prob_a) {

  int_4 num_classes;
  class_node_d->get_num_values_cc(num_classes);

  // for debugging purpose
  //
  num_nodes_d += 2;
  printf ("Number of tree nodes: %d\n", num_nodes_d);

  left_child_a->set_count_cc();
  left_child_a->set_probability_cc(left_prob_a, num_classes);
  right_child_a->set_count_cc();
  right_child_a->set_probability_cc(right_prob_a, num_classes);
  
  // insert the children into the node
  //
  tree_d->insert_cc(node_a, left_child_a);
  tree_d->insert_cc(node_a, right_child_a);

  // exit gracefully
  //
  return ISIP_TRUE;
}


