// file: $DT/class/tree/v1.0/dt_split_0.cc
//

// isip include files
//
#include "tree_node.h"
#include "tree.h"
#include "decision_tree.h"

#include <integral_constants.h>
#include "tree_node_constants.h"

// method: split_cc
//
// arguments:
//  int_4 dt_split_a: (input) splitting algorithm to be used
//  Tree_node* node_a: (input/output) pointer to tree being built
//
// return: logical_1 flag to indicate status
//
// this method grows a tree using the user's indicated splitting rule
//
logical_1 Decision_tree::split_cc(int_4 dt_split_a,
				  Tree_node* node_a=(Tree_node*)NULL) {

  // if this is the root of the tree and it's NULL, put the data
  // in the tree
  //
  if (node_a == (Tree_node*)NULL) {
    Tree_node* root = new Tree_node();
    tree_d->insert_cc(node_a, root);  

    // add linked list of data node pointers
    //
    Linked_list* ll_data = data_list_d;
    Data_node* data_a;
    while (ll_data) {
      data_a = (Data_node*)ll_data->get_node_cc();
      root->add_data_node_cc(data_a);
      ll_data = ll_data->get_next_cc();
    }

    num_nodes_d = 1;
    printf ("Number of tree nodes: %d\n", num_nodes_d);

    node_a = tree_d->get_root_cc();
  }
  
  // create the children of the current node
  //
  Tree_node* left_child = new Tree_node();
  Tree_node* right_child = new Tree_node();

  // find best split at this node
  //
  logical_1 not_pure;
  not_pure = not_pure_cc(node_a);

  if (not_pure == ISIP_TRUE) {

    if (best_split_cc(dt_split_a, node_a , left_child, right_child)
	== ISIP_TRUE) {
      
      // recursively find the right hand splits
      //
      split_cc(dt_split_a, right_child);
      
      // recursively find the left hand splits
      //
      split_cc(dt_split_a, left_child);
    }
    else {
      
      // delete the two nodes created that were never used because the
      // parent node was pure and no split was made
      //
      delete right_child;
      delete left_child;
    }
  }

  else {
    delete right_child;
    delete left_child;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
