// file: $DT/class/tree/v1.0/dt_split_11.cc
//

// isip include files
//
#include "tree_node_constants.h"
#include "tree_node.h"
#include "attribute_node_constants.h"
#include "attribute_node.h"
#include "tree.h"    
#include "decision_tree.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: find_max_split_cc
//
// arguments: attr_node:  the attribute is being split on
//            node: node for which the split is being found
//
// return: logical_1 indicating success
//
// this method determines the best discrete for a node and then
// applies this split
//
logical_1 Decision_tree::find_max_split_cc(float_4* calc_a, float_4* gain_a,
					   int_4& max_index) {

  float_4 total_gain = 0;
  int_4 gain_count = 0;
  float_4 gain_average;

  for (int_4 i=0;i<num_of_attributes_d;i++) {
    if (gain_a[i] != 0) {
      total_gain += gain_a[i];
      gain_count++;
    }
  }

  gain_average = total_gain / gain_count;
  
  float_4 max_a = ISIP_MINIMUM_FLOAT_4;
  max_index=DT_MAX_ATTR_NOT_FOUND;

  for (int_4 i=0; i<num_of_attributes_d; i++) {
    if (max_index != -1) {
      if ((calc_a[i] > max_a) && (gain_a[i] > gain_average - DT_EPSILON)) {
	max_a = calc_a[i];
	max_index = i;
      }
    }
    else {
      if ((calc_a[i] > ISIP_MINIMUM_FLOAT_4 * 0.5) &&
	  (gain_a[i] > gain_average - DT_EPSILON)) {
	max_index = i;
      }
    }
  }

  // exit gracefully
  //
  return ISIP_TRUE;
}


