// file: $DT/class/decision_tree/v1.0/dt_train_0.cc
//

// isip include files
//
#include "decision_tree.h"

#include <integral_constants.h>
#include "decision_tree_constants.h"

// method: train_cc
//
// arguments: none
//
// return: a logical_1 indicating status
//
// this method trains a decision tree from data
//
logical_1 Decision_tree::train_cc (char_1* output_fname_a) {

  // calculate prior probability
  //
  if (mode_split_d == DT_SPLIT_BAYES) {
    if (calculate_prior_prob_cc() != ISIP_TRUE) {
      error_handler_cc((char_1*)"train_cc",
		       (char_1*)"can not calculate prior prob");
    }
  }
      
  // call function to begin splitting
  //
  if (split_cc(mode_split_d) != ISIP_TRUE) {
    error_handler_cc((char_1*)"train_cc", (char_1*)"can not split tree");
  }

  // call function to begin pruning
  //
  if (prune_cc(mode_prune_d) != ISIP_TRUE) {
    error_handler_cc((char_1*)"train_cc",
		     (char_1*)"error pruning tree");
  }

  // output final tree
  //
  write_cc(tree_fname_d);

  // save the built tree to a file
  //
  int_4 display_mode = get_display_mode_cc();

  if (output_fname_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"train_cc",
		     (char_1*)"filename is NULL");
  }
    
  FILE* fp_out = fopen((char*)output_fname_a, "w");
  
  if (fp_out == (FILE*)NULL) {
    error_handler_cc((char_1*)"train_cc",
		     (char_1*)"unable to create file for writing");
  }
 
  if (display_cc(fp_out, display_mode) != ISIP_TRUE) {
    error_handler_cc((char_1*)"train_cc",
		     (char_1*)"unable to display tree");
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}


