// file: ll_link_1.cc
//

// isip include files
//
#include "linked_list.h"
#include <integral_constants.h>

// method: delete_cc
//
// arguments:
//  void_p node: (input) the utterance to be deleted from the list
//
// return: a logical value to indicate success
//
// this method deletes the link corresponding to the specified node
// from the linked list
//
logical_1 Linked_list::delete_cc(void_p node_a) {

  // set the current link to the specified node
  //
  set_current_cc(node_a);
  
  // if this node is to be deleted set a new node in the this position
  //
  if (curr_d == this) {
    Linked_list* lc = this;
    Linked_list* lp = this;
    while (lc->next_d != NULL) {
      lc->node_d = lc->next_d->node_d;
      lp = lc;
      lc = lc->next_d;
    }
    lc->node_d = NULL;
    delete lc;
    lp->next_d = NULL;
  }

  // otherwise adjust links
  //
  else {
  
    // get the previous and next links for this
    //
    Linked_list* prev = curr_d->prev_d;
    Linked_list* next = curr_d->next_d;
    
    // connect the two links directly
    //
    if (prev != NULL) {
      prev->next_d = next;
      curr_d->prev_d = NULL;
    }
    if (next != NULL) {
      next->prev_d = prev;
      curr_d->next_d = NULL;
    }

    delete curr_d;
    curr_d = prev;
  }
  
  // set the current node
  //
  for (Linked_list* ll = this; ll != NULL; ll = ll->next_d) {
    ll->curr_d = curr_d;
  }
  
  // exit gracefully
  //
  return ISIP_TRUE;
}
