// file: $DT/class/tree_node/v1.0/tn_get_8.cc
//

// system include files
//
#include <string.h>

// isip include files
//
#include "tree_node.h"
#include "tree_node_constants.h"
#include "decision_tree_constants.h"
#include <integral_constants.h>

// method: get_detailed_cc
//
// arguments: none
//
// return: string containing formatted data from the node
//
// this method returns the question asked at the node in string form that
// is formatted and tagged with the level it is on.  this is for use only
// with the output tree file intended for readin in of the tree.
//
logical_1 Tree_node::get_detailed_cc(char_1* formatted_data_a) {

  // check arguments
  //
  if (formatted_data_a == (char_1*)NULL) {
    error_handler_cc((char_1*)"get_detailed_cc",
		     (char_1*)"no memory allocated for input string");
  }
  
  char_1* count_str = new char_1[ISIP_MAX_STRING_LENGTH];
  char_1* prob_str = new char_1[ISIP_MAX_STRING_LENGTH];

  char_1* tmp_output = new char_1[ISIP_MAX_STRING_LENGTH*3];

  // get count at the node
  //
  if ( count_d == (int_4*)NULL ) {

    // output tag that no count
    //
    sprintf( (char*)count_str, "%s", (char*)TREE_NODE_NO_COUNT );
  }
  else {
    print_counts_cc(count_str);
  }

  // get probability at the node
  //
  if ( probability_d == (float_4*)NULL ) {

    // output tag that no probs
    //
    sprintf( (char*)prob_str, "%s", (char*)TREE_NODE_NO_PROBS );
  }
  else {
    print_probs_cc(prob_str);
  }

  char_1* question = new char_1[ISIP_MAX_STRING_LENGTH];
  get_question_cc(question);
  sprintf((char*)tmp_output, "<B%ld> %s%\n%s%s\n%s%s", level_d,
	  question, "c: ", count_str,"p: ", prob_str);
  delete [] question;

  strcpy ((char*)formatted_data_a, (char*)tmp_output);
  delete [] tmp_output;

  //  delete [] output_a;
  delete [] count_str;
  count_str = (char_1*)NULL;
  delete [] prob_str;
  prob_str = (char_1*)NULL;
  
  // return question at the tree node and exit gracefully
  //
  return ISIP_TRUE;
}

