// file: $DT/class/tree_node/v1.0/tn_size_0.cc
//

// isip include files
//
#include "tree_node.h"
#include <integral_constants.h>

// method: required size method
//
// arguments: none
//
// return: int_4 indicating the size of the tree node
//
int_4 Tree_node::size_cc() {
  
  // create size variable and set to the size of default protected
  // data
  //
  int_4 size = sizeof(debug_level_d);
  size += sizeof(parent_d);
  size += sizeof(children_d);
  size += sizeof(split_type_d);
  size += sizeof(label_d);
  size += sizeof(operator_d);
  size += sizeof(probability_d);
  size += sizeof(count_d);
  size += sizeof(level_d);
  size += sizeof(prune_value_d);
  size += sizeof(min_d);
  size += sizeof(max_d);
  size += sizeof(discrete_values_d);
  size += sizeof(num_discrete_values_d);
  size += sizeof(data_d);
  size += sizeof(num_data_nodes_d);

  // add the size of the list of children and each child's size
  // recursively
  //
  if (is_terminal_cc() == ISIP_FALSE) {
    Linked_list* ll = children_d;
    Tree_node* child_node;
    while (ll != (Linked_list*)NULL) {
      size += ll->size_cc();
      child_node = (Tree_node*)ll->get_node_cc();
      size += child_node->size_cc();
      ll = ll->get_next_cc();
    }
  }
  
  // add in the size of label_d
  //
  if (label_d != (char_1*)NULL) {
    size += (strlen((char*)label_d)+1) * sizeof(char_1);
  }
  
  // add in the size of probability_d
  //
  if (probability_d != (float_4*)NULL) {
    size += num_class_d * sizeof(float_4);
  }

  // add in the size of count_d
  //
  if (count_d != (int_4*)NULL) {
    size += num_class_d * sizeof(int_4);
  }

  // add in the size of discrete_values_d
  //
  if (discrete_values_d != (char_1**)NULL) {
    for (int_4 i=0;i<num_discrete_values_d;i++) {
      size += sizeof(discrete_values_d[i]);
      size += (strlen((char*)discrete_values_d[i])+1) * sizeof(char_1);
    }
  }

  // loop through to find the size of data_d (not including the size
  // of each of the data though since these are just pointers to the
  // data nodes
  //
  if (data_d != (Linked_list*)NULL) {
    Linked_list* ll = data_d;
    while (ll != (Linked_list*)NULL) {
      size += ll->size_cc();
      ll = ll->get_next_cc();
    }
  }

  // exit gracefully
  //
  return size;
}
